"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _helper = _interopRequireDefault(require("./helper"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default(babel) {
  const t = babel.types;
  ;

  class BabelInlineImport {
    constructor() {
      return {
        visitor: {
          ImportDeclaration: {
            exit(path, state) {
              const givenPath = path.node.source.value;
              let reference = state && state.file && state.file.opts.filename;
              const extensions = state && state.opts && state.opts.extensions;

              if (_helper.default.shouldBeInlined(givenPath, extensions)) {
                if (path.node.specifiers.length > 1) {
                  throw new Error(`Destructuring inlined import is not allowed. Check the import statement for '${givenPath}'`);
                }

                const id = path.node.specifiers[0].local.name;

                const content = _helper.default.getContents(givenPath, reference, extensions);

                const variable = t.variableDeclarator(t.identifier(id), t.stringLiteral(content));
                path.replaceWith({
                  type: 'VariableDeclaration',
                  kind: 'var',
                  declarations: [variable],
                  leadingComments: [{
                    type: 'CommentBlock',
                    value: ` babel-plugin-inline-import '${givenPath}' `
                  }]
                });
              }
            }

          }
        }
      };
    }

  }

  return new BabelInlineImport();
}